% author: Marcel Garling 2019
% COSY
clear; clc

% options
memory_start_size = 9; % one memory for all classes
memory_max_size = 30;
memory_start_content = 'data'; % 'data' or 'junk'
k = 3; % k nearest neighbours

load all_samples.mat
% generate all combinations of 3 from 7
P = nchoosek(1:7, 3)
tr_AS = tr_AS.*150;
tr_AS = tr_AS+300;
tr_AS = round(tr_AS)

tr_Sprudel = tr_Sprudel.*150;
tr_Sprudel = tr_Sprudel+300;
tr_Sprudel = round(tr_Sprudel)

tr_Bier = tr_Bier.*150;
tr_Bier = tr_Bier+300;
tr_Bier = round(tr_Bier)

tr_trainingResMatrix = tr_trainingResMatrix.*150;
tr_trainingResMatrix = tr_trainingResMatrix+300;
tr_trainingResMatrix = round(tr_trainingResMatrix)

result = [];
for comb = 1 : length(P(:,1))
    % select 3 features
    tr_AStest = tr_AS(:,P(comb,:));
    tr_Biertest = tr_Bier(:,P(comb,:));
    tr_Sprudeltest = tr_Sprudel(:,P(comb,:));
    tr_trainingResMatrixtest = tr_trainingResMatrix(:,P(comb,:));

    % fill repository
    antom = [];
    for repeat = 0:300

        rep = [tr_Biertest;tr_Sprudeltest;tr_AStest];
        repY = [ones(size(tr_Biertest,1),1);ones(size(tr_Biertest,1),1).*2;ones(size(tr_Biertest,1),1).*3];
        rng(repeat);
        perm = randperm(size(rep,1));
        rep = rep(perm,:);
        repY = repY(perm,:);

        % % accuracy before learning
        % fill memory with start elements
        if strcmp(memory_start_content,'data')
            mem = rep(1:memory_start_size,:);
            memY = repY(1:memory_start_size,:);
        else 
            junk = rand(memory_start_size,3);
            mem = junk;
            memY = floor(3*rand(size(mem,1),1)+1);
        end

            memOld = mem;
            memYOld = memY;
       % fprintf("Start accuracy: %.10f\n", testKnn2(mem,memY,rep,repY,memory_start_size, k));

        % % Leaning phase
        % % fill memory
        % if strcmp(memory_start_content,'data')
        %     mem = rep(1:memory_start_size,:,:);
        % else 
        %     mem = junk;
        % end

        p = memory_start_size + 1;
        q = memory_start_size + 1;

        total = 0;
        correct = 0;


        while p <= size(rep,1)
            % classify
            % get next drink
            x = rep(p,:);
            y = repY(p,:);

            % calculate euclidean distances
            euc = sqrt(sum((x - mem) .^2 , 2));

             % get classes of elements with smallest distances
            counter = zeros(3,1);
            for i=1:k
                [num, index] = min(euc);
                page = memY(index);
                counter(page) = counter(page) + 1;

                % identify
                ind = find(euc == num,1);
                euc(ind) = NaN;
            end
            [confidence,yi] = max(counter);


            if yi == y
                correct = correct + 1;
                incorrect = false;
            else
                incorrect = true;
            end
            total = total + 1;

            % add to memory
            if p <= memory_max_size
                mem(p,:) = x;
                memY(p) = y;
            else
                % determine an "unnecessary" entry and delete
                breakflag = false;
                if incorrect
                    confidence = 0;
                end

                for ki=k:confidence   % bugfix note: das ist im Grund gleichbedeutend mit (if confidence == k)
                    for j=1:memory_max_size
                        xc = mem(j,:);
                        yc = memY(j);
                        % calculate euclidean distances
                        eucc = sqrt(sum((xc - mem) .^2 , 2));

                        % get classes of elements with smallest distances
                        counterc = zeros(3,1);
                        for i=1:k+1
                            [num, index] = min(eucc);
                            page = memY(index);
                            counterc(page) = counterc(page) + 1;

                            % identify
                            ind = find(eucc == num,1);
                            eucc(ind) = NaN;        
                        end
                        counterc(yc) = counterc(yc) - 1;
                        [confc, yic] = max(counterc);

                        if confc == ki && yic == yc
                            mem(j,:) = x;
                            breakflag = true;
                            break;
                        end
                    end
                    if breakflag
                        breakflag = false;
                        break;
                    end
                end
            end 
           % fprintf("During accuracy: %.10f\n", testKnn2(mem,memY,rep,repY,memory_start_size, k));
            p = p + 1;
        end

    % % accuracy after learning
        n1 = testKnn2(memOld,memYOld,rep,repY,memory_start_size, k);
        n2 = testKnn2(mem,memY,rep,repY,memory_start_size, k);
        antom = [antom; n1, n2, n2-n1];
    fprintf("before: %.3f\tafter: %.3f\tdifference: %.3f\n",antom(end,1), antom(end,2),...
    antom(end,3));
    end
    [rown1,coln1] = max(antom(:,1));
    [rown2,coln2] = max(antom(:,2));
    [rown3,coln3] = max(antom(:,3));
    [rown4,coln4] = min(antom(:,3));
    result = [result; coln1, antom(coln1,:), coln2, antom(coln2,:), coln3, antom(coln3,:), coln4, antom(coln4,:), mean(antom), std(antom), P(comb,:)];
    
end
result = [result; max(result)];
save('datatest','result');
disp(mean(antom));
disp(std(antom));
disp(max(antom));